;_______________________________________________________________
;|picomire, video fake 						|
;|turning a pic 12C508/509 into a video pattern generator	|
;|release V1.0							|
;|(c) FLorent Simonnot 2002					|
;|if you like it tell me :fsimonnot@free.fr			|
;_______________________________________________________________|
	list	p=12c508
	radix dec
	include "p12c508.inc"
	include "vdofake.inc"
	__config _MCLRE_OFF & _CP_OFF & _WDT_OFF & _XT_OSC

;#define		debug
	ifdef   debug
        messg "!!!!!!!!!!!!!debug version!!!!!!!!!!!!!!"	
	endif       

data_vdo	UDATA 0x10
LOOP_CTRL	res	1
DELAY		res	1
LINE_COUNT	res	1
PATTERN		res	1
;______________calibration_______________________________________
main	code	0x00
main
;_________________________________________initialisation_________
	xorlw	0xff			;room for a patch
	xorlw	0xff
	movlw	~(LVL1MSK | LVL0MSK)	;initialize pin buffers
	tris	GPIO
	BLACKLVL
;________________________________________________________________
	movlw	11			;initialize counters
	movwf	LINE_COUNT	
	movlw	12
	movwf	PATTERN

StartFrame 
start_pattern
	BLCKLVL			;2us	|		11 "inversed chess" line
	call	inv_chess	;59us	|	
	decfsz	LINE_COUNT,f	;1us	|
	goto	$-4		;2us	|64us

				;1us btfss latency 
	nop			;1us			|1 black line
	BLCKLVL			;2us			|between 2 loops
	movlw	12		;1us			|
	movwf	LINE_COUNT	;1us			|
	nop			;1us			|
	call	delay8us	;10us (8+2)		|	
	call	delay18us	;20us (18+2)		|	
	call	delay18us	;20us (18+2)		|	
	BLCKLVL			;2us			|
	TOPLVL			;2us			|
	nop			;1us			|
	nop			;1us			|
	nop			;1us			|
	nop			;1us			|
	nop			;1us			|

	BLCKLVL			;2us	|		12 "chess" line
	call	chess		;59us	|	
	decfsz	LINE_COUNT,f	;1us	|
	goto	$-4		;2us	|64us

				;1us btfss latency  
	nop			;1us			|1 black line
	BLCKLVL			;2us			|between 2 loops
	nop			;1us			|
	nop			;1us			|
	nop			;1us			|
	call	delay4us	;6us (4+2)		|	
	call	delay18us	;20us (18+2)		|
	call	delay18us	;20us (18+2)		|
	decfsz	PATTERN,f	;1us			|	
	goto	pattern_again	;2us			|
	goto 	end_frame	;2us			|

pattern_again
				;1us btfss latency 
	nop			;1us			|
	BLCKLVL			;2us			|
	TOPLVL			;2us			|
	nop			;1us			|
	movlw	11		;1us			|
	movwf	LINE_COUNT	;1us			|
	goto	start_pattern	;2us			|repeating the pattern 25 times

end_frame
	BLCKLVL			;2us			|at this point we have synthetize 
	TOPLVL			;2us			|300 video lines
	call	line		;64us			4 black lines more
	call	line		;64us
	call	line		;64us
	call	line		;64us


	BLCKLVL			;2us	*-		|start of frame synchro
	call	delay18us	;20us (18+2) _
	call	delay2us	;4us
	nop			;1us
	nop			;1us

	call	half_line_pos	;32us
	call	half_line_pos	;32us
	call	half_line_pos	;32us
	call	half_line_pos	;32us
	nop			;1us	
	nop			;1us	
	TOPLVL			;2us	*-
	call	delay18us	;20us (18+2)	
	nop			;1us
	nop			;1us
	nop			;1us	
	call	half_line_neg	;32us
	call	half_line_neg	;32us
	call	half_line_neg	;32us
	call	half_line_neg	;32us
	nop			;1us	
	nop			;1us	
	BLCKLVL			;2us
	nop			;1us
	call	half_line_pos	;32us
	call	half_line_pos	;32us
	call	half_line_pos	;32us
	call	half_line_pos	;32us
							;|end of frame synchro
	nop			;1us			;|start of the first line
	TOPSYN			;2us			;|of the next frame
	call	delay18us	;20us (18+2)	
	call	delay18us	;20us (18+2)
	nop			;1us
	nop			;1us
	movlw	11		;1us
	movwf	LINE_COUNT	;1us
	movlw	12		;1us
	movwf	PATTERN		;1us

	goto	StartFrame	;2us

;_______________black line generation ___________________________
;routine lengh 57us
;
line	
	nop				;1us
	BLCKLVL				;2us
	movlw	13			;1us
	movwf	LOOP_CTRL		;1us
	decf	LOOP_CTRL,f		;|(4*LOOP_CTRL-1) i.e. 51us
	btfss	STATUS,Z		;|
	goto	$-2			;|
	BLCKLVL				;2us 
	TOPLVL				;2us
	retlw	0			;2us
		
;_______________half line positive generation____________________
half_line_pos
	TOPLVL			;2us	*_
	BLCKLVL			;2us	*-
	call	delay18us	;20us (18+2) _
	nop			;1us
	nop			;1us
	nop			;1us
	nop			;1us
	retlw	0		;2us
;*_ _- -------------------- ---- -- 

;_______________half line negative generation____________________
half_line_neg
	BLCKLVL			;2us	*_
	nop			;1us
	nop			;1us
	nop			;1us
	TOPLVL			;2us	*-
	call	delay18us	;20us (18+2) _
	nop			;1us
	retlw	0		;2us


;_______________6us delay routine________________________________
delay4us
	nop		;1us
	nop		;1us
	retlw	0	;2us

;_______________18us delay routine_______________________________
delay18us
	movlw	5	;1us
	movwf	DELAY	;1us
	decfsz	DELAY,f	;|(3*delay-1)us
	goto	$-1	;|
	retlw	0	;2us

;_______________8us delay routine________________________________
delay8us
	nop		;1us
	nop		;1us
	nop		;1us
	nop		;1us
	nop		;1us
	nop		;1us
	retlw	0	;2us
;_______________2us delay routine________________________________
delay2us
	retlw	0	;2us
;_______________"chess reversed" line generation_________________
;longueur d'exe de la routine 57us
;
inv_chess
	nop				;1us
	WHITELVL			;2us la ligne visible commence ici
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us la ligne visible finie ici
	TOPLVL				;2us
	retlw	0			;2us
;_______________"chess " line generation_________________________
chess
	nop				;1us
	WHITELVL			;2us la ligne visible commence ici
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	BLCKLVL				;2us
	WHITELVL			;2us
	WHITELVL			;2us
	BLCKLVL				;2us la ligne visible finie ici
	TOPLVL				;2us
	retlw	0			;2us
	end
